Index: /pykota/trunk/man/edpykota.1
===================================================================
--- /pykota/trunk/man/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/sv_SE/edpykota.1
===================================================================
--- /pykota/trunk/man/sv_SE/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/sv_SE/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/pt/edpykota.1
===================================================================
--- /pykota/trunk/man/pt/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/pt/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/tr/edpykota.1
===================================================================
--- /pykota/trunk/man/tr/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/tr/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/el_GR/edpykota.1
===================================================================
--- /pykota/trunk/man/el_GR/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/el_GR/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/de/edpykota.1
===================================================================
--- /pykota/trunk/man/de/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/de/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/nb_NO/edpykota.1
===================================================================
--- /pykota/trunk/man/nb_NO/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/nb_NO/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/zh_TW/edpykota.1
===================================================================
--- /pykota/trunk/man/zh_TW/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/zh_TW/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/pt_BR/edpykota.1
===================================================================
--- /pykota/trunk/man/pt_BR/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/pt_BR/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/fr/edpykota.1
===================================================================
--- /pykota/trunk/man/fr/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/fr/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/es/edpykota.1
===================================================================
--- /pykota/trunk/man/es/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/es/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/pl/edpykota.1
===================================================================
--- /pykota/trunk/man/pl/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/pl/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/th/edpykota.1
===================================================================
--- /pykota/trunk/man/th/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/th/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR
Index: /pykota/trunk/man/it/edpykota.1
===================================================================
--- /pykota/trunk/man/it/edpykota.1 (revision 2713)
+++ /pykota/trunk/man/it/edpykota.1 (revision 2720)
@@ -30,4 +30,6 @@
 Users or groups are never deleted, you have
 to use the pkusers command to delete them.
+The history will be purge from all matching
+jobs, unless \fB\-g\fR | \fB\-\-groups\fR is used.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -42,4 +44,7 @@
 Edit groups print quota entries instead of
 users print quota entries.
+.TP
+\fB\-L\fR | \fB\-\-list\fR
+Lists users or groups print quota entries.
 .TP
 \fB\-n\fR | \fB\-\-noquota\fR