Index: /pykota/trunk/bin/pkbcodes
===================================================================
--- /pykota/trunk/bin/pkbcodes (revision 2723)
+++ /pykota/trunk/bin/pkbcodes (revision 2725)
@@ -131,5 +131,6 @@
             if options["list"] :
                 for billingcode in billingcodes :
-                    print "%s [%s] %s %s %s %.2f %s" % \
+                    if billingcode.Exists :
+                        print "%s [%s] %s %s %s %.2f %s" % \
                           (billingcode.BillingCode, billingcode.Description, \
                            billingcode.PageCounter, \
Index: /pykota/trunk/bin/pkusers
===================================================================
--- /pykota/trunk/bin/pkusers (revision 2724)
+++ /pykota/trunk/bin/pkusers (revision 2725)
@@ -241,31 +241,33 @@
                     smtpserver = self.config.getSMTPServer()
                     for entry in entries :
-                        email = entry.Email
-                        if not email :
-                            if maildomain :     
-                                email = "%s@%s" % (entry.Name, maildomain)
-                            elif smtpserver :    
-                                email = "%s@%s" % (entry.Name, smtpserver)
-                            else :    
-                                email = "%s@%s" % (entry.Name, "localhost")
-                        msg = "%s - <%s>" % (entry.Name, email)
-                        if entry.Description :
-                            msg += " - %s" % entry.Description
-                        print msg    
-                        print "    %s" % (_("Limited by : %s") % entry.LimitBy)
-                        print "    %s" % (_("Account balance : %.2f") % (entry.AccountBalance or 0.0))
-                        print "    %s" % (_("Total paid so far : %.2f") % (entry.LifeTimePaid or 0.0))
-                        print "    %s" % (_("Overcharging factor : %.2f") % entry.OverCharge)
-                        print
+                        if entry.Exists :
+                            email = entry.Email
+                            if not email :
+                                if maildomain :     
+                                    email = "%s@%s" % (entry.Name, maildomain)
+                                elif smtpserver :    
+                                    email = "%s@%s" % (entry.Name, smtpserver)
+                                else :    
+                                    email = "%s@%s" % (entry.Name, "localhost")
+                            msg = "%s - <%s>" % (entry.Name, email)
+                            if entry.Description :
+                                msg += " - %s" % entry.Description
+                            print msg    
+                            print "    %s" % (_("Limited by : %s") % entry.LimitBy)
+                            print "    %s" % (_("Account balance : %.2f") % (entry.AccountBalance or 0.0))
+                            print "    %s" % (_("Total paid so far : %.2f") % (entry.LifeTimePaid or 0.0))
+                            print "    %s" % (_("Overcharging factor : %.2f") % entry.OverCharge)
+                            print
                 else :    
                     for entry in entries :
-                        msg = "%s" % entry.Name
-                        if entry.Description :
-                            msg += " - %s" % entry.Description
-                        print msg    
-                        print "    %s" % (_("Limited by : %s") % entry.LimitBy)
-                        print "    %s" % (_("Group balance : %.2f") % (entry.AccountBalance or 0.0))
-                        print "    %s" % (_("Total paid so far : %.2f") % (entry.LifeTimePaid or 0.0))
-                        print
+                        if entry.Exists :
+                            msg = "%s" % entry.Name
+                            if entry.Description :
+                                msg += " - %s" % entry.Description
+                            print msg    
+                            print "    %s" % (_("Limited by : %s") % entry.LimitBy)
+                            print "    %s" % (_("Group balance : %.2f") % (entry.AccountBalance or 0.0))
+                            print "    %s" % (_("Total paid so far : %.2f") % (entry.LifeTimePaid or 0.0))
+                            print
             else :
                 self.display("%s...\n" % _("Modification"))
Index: /pykota/trunk/bin/pkprinters
===================================================================
--- /pykota/trunk/bin/pkprinters (revision 2724)
+++ /pykota/trunk/bin/pkprinters (revision 2725)
@@ -174,15 +174,14 @@
             if options["list"] :
                 for printer in printers :
-                    parents = ", ".join([p.Name for p in self.storage.getParentPrinters(printer)])
-                    if parents : 
-                        parents = "%s %s" % (_("in"), parents)
-                    print "%s [%s] (%s + #*%s)" % \
-                          (printer.Name, printer.Description, printer.PricePerJob, \
-                           printer.PricePerPage)
-                    print "    %s" % (_("Passthrough mode : %s") % ((printer.PassThrough and _("ON")) or _("OFF")))
-                    print "    %s" % (_("Maximum job size : %s") % ((printer.MaxJobSize and (_("%s pages") % printer.MaxJobSize)) or _("Unlimited")))
-                    if parents :       
-                        print "    %s" % parents
-                    print    
+                    if printer.Exists :
+                        parents = ", ".join([p.Name for p in self.storage.getParentPrinters(printer)])
+                        print "%s [%s] (%s + #*%s)" % \
+                              (printer.Name, printer.Description, printer.PricePerJob, \
+                               printer.PricePerPage)
+                        print "    %s" % (_("Passthrough mode : %s") % ((printer.PassThrough and _("ON")) or _("OFF")))
+                        print "    %s" % (_("Maximum job size : %s") % ((printer.MaxJobSize and (_("%s pages") % printer.MaxJobSize)) or _("Unlimited")))
+                        if parents : 
+                            print "    %s %s" % (_("in"), parents)
+                        print    
             else :
                 self.display("%s...\n" % _("Modification"))