Index: pykota/trunk/man/edpykota.1
===================================================================
--- pykota/trunk/man/edpykota.1 (revision 2720)
+++ pykota/trunk/man/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/sv_SE/edpykota.1
===================================================================
--- pykota/trunk/man/sv_SE/edpykota.1 (revision 2720)
+++ pykota/trunk/man/sv_SE/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/pt/edpykota.1
===================================================================
--- pykota/trunk/man/pt/edpykota.1 (revision 2720)
+++ pykota/trunk/man/pt/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/tr/edpykota.1
===================================================================
--- pykota/trunk/man/tr/edpykota.1 (revision 2720)
+++ pykota/trunk/man/tr/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/el_GR/edpykota.1
===================================================================
--- pykota/trunk/man/el_GR/edpykota.1 (revision 2720)
+++ pykota/trunk/man/el_GR/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/de/edpykota.1
===================================================================
--- pykota/trunk/man/de/edpykota.1 (revision 2720)
+++ pykota/trunk/man/de/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/nb_NO/edpykota.1
===================================================================
--- pykota/trunk/man/nb_NO/edpykota.1 (revision 2720)
+++ pykota/trunk/man/nb_NO/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/zh_TW/edpykota.1
===================================================================
--- pykota/trunk/man/zh_TW/edpykota.1 (revision 2720)
+++ pykota/trunk/man/zh_TW/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/pt_BR/edpykota.1
===================================================================
--- pykota/trunk/man/pt_BR/edpykota.1 (revision 2720)
+++ pykota/trunk/man/pt_BR/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/fr/edpykota.1
===================================================================
--- pykota/trunk/man/fr/edpykota.1 (revision 2720)
+++ pykota/trunk/man/fr/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/es/edpykota.1
===================================================================
--- pykota/trunk/man/es/edpykota.1 (revision 2720)
+++ pykota/trunk/man/es/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/pl/edpykota.1
===================================================================
--- pykota/trunk/man/pl/edpykota.1 (revision 2720)
+++ pykota/trunk/man/pl/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/th/edpykota.1
===================================================================
--- pykota/trunk/man/th/edpykota.1 (revision 2720)
+++ pykota/trunk/man/th/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
Index: pykota/trunk/man/it/edpykota.1
===================================================================
--- pykota/trunk/man/it/edpykota.1 (revision 2720)
+++ pykota/trunk/man/it/edpykota.1 (revision 2727)
@@ -61,4 +61,8 @@
 for the user or group to zero on the specified
 printers. This is a shortcut for '\-\-used 0'.
+.TP
+\fB\-s\fR | \fB\-\-skipexisting\fR
+In combination with the \fB\-\-add\fR option above, tells
+edpykota to not modify existing print quota entries.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl