Index: pykota/trunk/pykota/storages/sql.py
===================================================================
--- pykota/trunk/pykota/storages/sql.py (revision 2754)
+++ pykota/trunk/pykota/storages/sql.py (revision 2756)
@@ -483,97 +483,4 @@
         return codes        
         
-    def getPrintersUsersAndPQuotas(self, pnames = ["*"], unames=["*"]) :    
-        """Returns all printers, users and users print quota entries which match a set of names."""
-        matchunames = {}
-        matchpnames = {}
-        printers = {}
-        users = {}
-        upquotas = {}
-        result = self.doSearch("SELECT users.id AS uid, users.description AS udesc, printers.id AS pid, printers.description AS pdesc, printers.maxjobsize AS pmaxjobsize, userpquota.id AS upqid, userpquota.maxjobsize AS upqmaxjobsize, users.*, printers.*, userpquota.* FROM users, printers, userpquota WHERE users.id=userpquota.userid AND printers.id=userpquota.printerid;")
-        if result :
-            for record in result :
-                uname = self.databaseToUserCharset(record.get("username"))
-                pname = self.databaseToUserCharset(record.get("printername"))
-                if not matchpnames.has_key(pname) :
-                    matchpnames[pname] = printermatches = self.tool.matchString(pname, pnames)
-                else :    
-                    printermatches = matchpnames[pname]
-                if printermatches :    
-                    if not matchunames.has_key(uname) :
-                        matchunames[uname] = usermatches = self.tool.matchString(uname, unames)
-                    else :    
-                        usermatches = matchunames[uname]
-                    if usermatches :    
-                        printer = StoragePrinter(self, pname)
-                        printer.ident = record.get("pid")
-                        printer.PricePerJob = record.get("priceperjob") or 0.0
-                        printer.PricePerPage = record.get("priceperpage") or 0.0
-                        printer.Description = self.databaseToUserCharset(record.get("pdesc") or "") 
-                        printer.MaxJobSize = record.get("pmaxjobsize") or 0
-                        printer.PassThrough = record.get("passthrough") or 0
-                        if printer.PassThrough in (1, "1", "t", "true", "TRUE", "True") :
-                            printer.PassThrough = 1
-                        else :
-                            printer.PassThrough = 0
-                        printer.Exists = 1
-                        printers[pname] = printer
-                        self.cacheEntry("PRINTERS", pname, printer)
-                        
-                        user = StorageUser(self, uname)
-                        user.ident = record.get("uid")
-                        user.LimitBy = record.get("limitby") or "quota"
-                        user.AccountBalance = record.get("balance")
-                        user.LifeTimePaid = record.get("lifetimepaid")
-                        user.Email = record.get("email") 
-                        user.OverCharge = record.get("overcharge")
-                        user.Description = self.databaseToUserCharset(record.get("udesc"))
-                        user.Exists = 1
-                        users[uname] = user
-                        self.cacheEntry("USERS", uname, user)
-                        
-                        upqkey = "%s@%s" % (uname, pname)
-                        userpquota = StorageUserPQuota(self, user, printer)
-                        userpquota.ident = record.get("id")
-                        userpquota.PageCounter = record.get("pagecounter")
-                        userpquota.LifePageCounter = record.get("lifepagecounter")
-                        userpquota.SoftLimit = record.get("softlimit")
-                        userpquota.HardLimit = record.get("hardlimit")
-                        userpquota.DateLimit = record.get("datelimit")
-                        userpquota.WarnCount = record.get("warncount")
-                        userpquota.Exists = 1
-                        upquotas[upqkey] = userpquota
-                        self.cacheEntry("USERPQUOTAS", upqkey, userpquota)
-        return (printers, users, upquotas)
-        
-    def getPrintersGroupsAndPQuotas(self, pnames = ["*"], gnames=["*"]) :    
-        """Returns all printers, groups and groups print quota entries which match a set of names."""
-        matchgnames = {}
-        matchpnames = {}
-        printers = {}
-        groups = {}
-        gpquotas = {}
-        result = self.doSearch("SELECT printername, groupname FROM printers, groups")
-        if result :
-            for record in result :
-                gname = self.databaseToUserCharset(record.get("groupname"))
-                pname = self.databaseToUserCharset(record.get("printername"))
-                if not matchpnames.has_key(pname) :
-                    matchpnames[pname] = printermatches = self.tool.matchString(pname, pnames)
-                else :    
-                    printermatches = matchpnames[pname]
-                if printermatches :    
-                    if not matchgnames.has_key(gname) :
-                        matchgnames[gname] = groupmatches = self.tool.matchString(gname, gnames)
-                    else :    
-                        groupmatches = matchgnames[gname]
-                    if groupmatches :    
-                        printer = self.getPrinter(pname)
-                        printers[pname] = printer
-                        group = self.getGroup(gname)
-                        groups[gname] = group
-                        gpqkey = "%s@%s" % (gname, pname)
-                        gpquotas[upqkey] = self.getGroupPQuota(group, printer)
-        return (printers, groups, gpquotas)
-        
     def getPrinterUsersAndQuotas(self, printer, names=["*"]) :        
         """Returns the list of users who uses a given printer, along with their quotas."""
Index: pykota/trunk/pykota/storages/ldapstorage.py
===================================================================
--- pykota/trunk/pykota/storages/ldapstorage.py (revision 2754)
+++ pykota/trunk/pykota/storages/ldapstorage.py (revision 2756)
@@ -866,34 +866,4 @@
         return usersandquotas
                 
-    def getPrintersUsersAndPQuotas(self, pnames = ["*"], unames=["*"]) :    
-        """Returns all printers, users and users print quota entries which match a set of names."""
-        printers = {}
-        users = {}
-        upquotas = {}
-        for printer in self.getMatchingPrinters(",".join(pnames)) :
-            printers[printer.Name] = printer
-        for user in self.getMatchingUsers(",".join(unames)) :
-            users[user.Name] = user
-        for (p, printer) in printers.items() :
-            for (u, user) in users.items() :
-                upqkey = "%s@%s" % (u, p)
-                upquotas[upqkey] = self.getUserPQuota(user, printer)
-        return (printers, users, upquotas)
-        
-    def getPrintersGroupsAndPQuotas(self, pnames = ["*"], gnames=["*"]) :    
-        """Returns all printers, groups and groups print quota entries which match a set of names."""
-        printers = {}
-        groups = {}
-        gpquotas = {}
-        for printer in self.getMatchingPrinters(",".join(pnames)) :
-            printers[printer.Name] = printer
-        for group in self.getMatchingGroups(",".join(gnames)) :
-            groups[group.Name] = group
-        for (p, printer) in printers.items() :
-            for (g, group) in groups.items() :
-                gpqkey = "%s@%s" % (g, p)
-                gpquotas[gpqkey] = self.getGroupPQuota(group, printer)
-        return (printers, groups, gpquotas)
-        
     def getPrinterGroupsAndQuotas(self, printer, names=["*"]) :        
         """Returns the list of groups which uses a given printer, along with their quotas."""